using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.Editors;


namespace ObservableCollectionXamComboEditor
{
    class Data : IComparable<Data>
    {
       #region Fields
        private int id;
        private string name;
        #endregion

        #region Constructor
        public Data(int id, string name)
        {
            this.id = id;
            this.name = name;
        }
        #endregion

        public int ID
        {
            get { return id; }
        }

        public string Name
        {
            get { return name; }
        }

        #region IComparable<Data> Members

        public int CompareTo(Data other)
        {
            return this.ID.CompareTo(other.ID);
        }

        public override bool Equals(object obj)
        {
            if (obj is Data) { return this.CompareTo(obj as Data) == 0; }
            return false;
        }

        #endregion
    }

    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : System.Windows.Window
    {

        private ObservableCollection<Data> datas = new ObservableCollection<Data>();

        public Window1()
        {
            /* Changing the drop dow to B, E, F, H or J 
             * will raise ValueChanged/SelectedItemChanged twice. WTF */

            InitializeComponent();

            Data a = new Data(83,"A");
            datas.Add(a);

            a = new Data(112, "B");
            datas.Add(a);

            a = new Data(1, "C");
            datas.Add(a);

            a = new Data(31,"D");
            datas.Add(a);

            a = new Data(125,"E");
            datas.Add(a);

            a = new Data(129,"F");
            datas.Add(a);

            a = new Data(88,"G");
            datas.Add(a);

            a = new Data(122,"H");
            datas.Add(a);

            a = new Data(94,"I");
            datas.Add(a);

            a = new Data(119,"J");
            datas.Add(a);

            if (comboEditor.ItemsProvider == null) comboEditor.ItemsProvider = new ComboBoxItemsProvider();
            comboEditor.ItemsProvider.DisplayMemberPath = "Name";
            comboEditor.ItemsProvider.ValuePath = "ID";
            comboEditor.ItemsProvider.ItemsSource = datas;

            comboEditor.SelectedItemChanged += new RoutedPropertyChangedEventHandler<object>(comboEditor_SelectedItemChanged);
            comboEditor.ValueChanged += new RoutedPropertyChangedEventHandler<object>(comboEditor_ValueChanged);
        }


        int j = 0;

        void comboEditor_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            Data a = e.OldValue as Data;
            Data b = e.NewValue as Data;

            string astr = a == null ? "NULL" : string.Format("[ {0} : {1} ]", a.Name, a.ID);
            string bstr = b == null ? "NULL" : string.Format("[ {0} : {1} ]", b.Name, b.ID);


            Console.WriteLine("Value changed from {0} to {1}",
                astr, bstr);
        }
        void comboEditor_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            j++;
            Console.WriteLine("{0}: value changed ...", j);
        }

    }
}